diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index 89ae995..7320316 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -5151,9 +4305,6 @@ _cl5GetOperation(Object *replica, slapi_operation_parameters *op)
     }
 
 done:
-    if (obj)
-        object_release(obj);
-
     slapi_ch_free(&(data.data));
 
     return rc;
@@ -5211,10 +4362,9 @@ struct replica_hash_entry
 
 
 static int
-_cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Object *replica, Object *fileObj, CL5ReplayIterator **iterator, int *continue_on_missing)
+_cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Object *repl_obj, CL5ReplayIterator **iterator, int *continue_on_missing)
 {
     CLC_Buffer *clcache = NULL;
-    CL5DBFile *file;
     CSN *startCSN = NULL;
     char csnStr[CSN_STRSIZE];
     int rc = CL5_SUCCESS;
@@ -5223,13 +4373,14 @@ _cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Objec
     PRBool haveChanges = PR_FALSE;
     char *agmt_name;
 
-    PR_ASSERT(consumerRuv && replica && fileObj && iterator);
+    Replica *replica = (Replica*)object_get_data(repl_obj);
+    cldb_Handle *cldb = replica_get_file_info(replica);
+ 
+    PR_ASSERT (consumerRuv && replica && iterator);
     csnStr[0] = '\0';
 
-    file = (CL5DBFile *)object_get_data(fileObj);
-
     /* get supplier's RUV */
-    supplierRuvObj = replica_get_ruv((Replica *)object_get_data(replica));
+    supplierRuvObj = replica_get_ruv(replica);
     PR_ASSERT(supplierRuvObj);
 
     if (!supplierRuvObj) {
@@ -5252,7 +4403,7 @@ _cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Objec
 
     /* initialize the changelog buffer and do the initial load */
 
-    rc = clcache_get_buffer(&clcache, file->db, consumerRID, consumerRuv, supplierRuv);
+    rc = clcache_get_buffer(&clcache, cldb->db, consumerRID, consumerRuv, supplierRuv);
     if (rc != 0)
         goto done;
 
@@ -5276,7 +4427,7 @@ _cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Objec
             goto done;
         }
         /* check whether this csn should be present */
-        rc = _cl5CheckMissingCSN(startCSN, supplierRuv, file);
+        rc = _cl5CheckMissingCSN(startCSN, supplierRuv, cldb);
         if (rc == CL5_MISSING_DATA) /* we should have had the change but we don't */
         {
             if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
@@ -5314,7 +4465,7 @@ _cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Objec
         }
 
         /* ONREPL - should we make a copy of both RUVs here ?*/
-        (*iterator)->fileObj = fileObj;
+        (*iterator)->fileObj = cldb;
         (*iterator)->clcache = clcache;
         clcache = NULL;
         (*iterator)->consumerRID = consumerRID;
@@ -5481,7 +4632,7 @@ cl5DestroyCSNList(CSN ***csns)
         CL5_SUCCESS     if that has not and should not been seen by the server
  */
 static int
-_cl5CheckMissingCSN(const CSN *csn, const RUV *supplierRuv, CL5DBFile *file)
+_cl5CheckMissingCSN (const CSN *csn, const RUV *supplierRuv, cldb_Handle *cldb)
 {
     ReplicaId rid;
     CSN *supplierCsn = NULL;
@@ -5489,7 +4640,7 @@ _cl5CheckMissingCSN(const CSN *csn, const RUV *supplierRuv, CL5DBFile *file)
     int rc = CL5_SUCCESS;
     char csnStr[CSN_STRSIZE];
 
-    PR_ASSERT(csn && supplierRuv && file);
+    PR_ASSERT(csn && supplierRuv && cldb);
 
     rid = csn_get_replicaid(csn);
     ruv_get_largest_csn_for_replica(supplierRuv, rid, &supplierCsn);
@@ -5504,7 +4655,7 @@ _cl5CheckMissingCSN(const CSN *csn, const RUV *supplierRuv, CL5DBFile *file)
         return CL5_SUCCESS;
     }
 
-    ruv_get_largest_csn_for_replica(file->purgeRUV, rid, &purgeCsn);
+    ruv_get_largest_csn_for_replica(cldb->purgeRUV, rid, &purgeCsn);
     if (purgeCsn == NULL) {
         /* changelog never contained any changes for this replica */
         if (csn_compare(csn, supplierCsn) <= 0) {
@@ -5565,522 +4716,8 @@ _cl5CheckMissingCSN(const CSN *csn, const RUV *supplierRuv, CL5DBFile *file)
 
 /* Helper functions that work with individual changelog files */
 
-/* file name format : <replica name>_<replica generation>db{2,3,...} */
-static PRBool
-_cl5FileName2Replica(const char *file_name, Object **replica)
-{
-    Replica *r;
-    char *repl_name, *file_gen, *repl_gen;
-    int len;
-
-    PR_ASSERT(file_name && replica);
-
-    *replica = NULL;
-
-    /* this is database file */
-    if (_cl5FileEndsWith(file_name, DB_EXTENSION) ||
-        _cl5FileEndsWith(file_name, DB_EXTENSION_DB4) ||
-        _cl5FileEndsWith(file_name, DB_EXTENSION_DB3)) {
-        repl_name = slapi_ch_strdup(file_name);
-        file_gen = strstr(repl_name, FILE_SEP);
-        if (file_gen) {
-            int extlen = strlen(DB_EXTENSION);
-            *file_gen = '\0';
-            file_gen += strlen(FILE_SEP);
-            len = strlen(file_gen);
-            if (len <= extlen + 1) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5FileName2Replica - "
-                              "Invalid file name (%s)\n",
-                              file_name);
-            } else {
-                /* get rid of the file extension */
-                file_gen[len - extlen - 1] = '\0';
-                *replica = replica_get_by_name(repl_name);
-                if (*replica) {
-                    /* check that generation matches the one in replica object */
-                    r = (Replica *)object_get_data(*replica);
-                    repl_gen = replica_get_generation(r);
-                    PR_ASSERT(repl_gen);
-                    if (strcmp(file_gen, repl_gen) != 0) {
-                        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                                      "_cl5FileName2Replica - "
-                                      "Replica generation mismatch for replica at (%s), "
-                                      "file generation %s, new replica generation %s\n",
-                                      slapi_sdn_get_dn(replica_get_root(r)), file_gen, repl_gen);
-
-                        object_release(*replica);
-                        *replica = NULL;
-                    }
-                    slapi_ch_free((void **)&repl_gen);
-                }
-            }
-            slapi_ch_free((void **)&repl_name);
-        } else {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5FileName2Replica - "
-                                                               "Malformed file name - %s\n",
-                          file_name);
-        }
-
-        return PR_TRUE;
-    } else
-        return PR_FALSE;
-}
-
-/* file name format : <replica name>_<replica generation>db{2,3} */
-static char *
-_cl5Replica2FileName(Object *replica)
-{
-    const char *replName;
-    char *replGen, *fileName;
-    Replica *r;
-
-    PR_ASSERT(replica);
-
-    r = (Replica *)object_get_data(replica);
-    PR_ASSERT(r);
-
-    replName = replica_get_name(r);
-    replGen = replica_get_generation(r);
-
-    fileName = _cl5MakeFileName(replName, replGen);
-
-    slapi_ch_free((void **)&replGen);
-
-    return fileName;
-}
-
-static char *
-_cl5MakeFileName(const char *replName, const char *replGen)
-{
-    char *fileName = slapi_ch_smprintf("%s/%s%s%s.%s",
-                                       s_cl5Desc.dbDir, replName,
-                                       FILE_SEP, replGen, DB_EXTENSION);
-
-    return fileName;
-}
-
-/* open file that corresponds to a particular database */
-static int
-_cl5DBOpenFile(Object *replica, Object **obj, PRBool checkDups)
-{
-    int rc;
-    const char *replName;
-    char *replGen;
-    Replica *r;
-
-    PR_ASSERT(replica);
-
-    r = (Replica *)object_get_data(replica);
-    replName = replica_get_name(r);
-    PR_ASSERT(replName);
-    replGen = replica_get_generation(r);
-    PR_ASSERT(replGen);
-
-    rc = _cl5DBOpenFileByReplicaName(replName, replGen, obj, checkDups);
-
-    slapi_ch_free((void **)&replGen);
-
-    return rc;
-}
-
-static int
-_cl5DBOpenFileByReplicaName(const char *replName, const char *replGen, Object **obj, PRBool checkDups)
-{
-    int rc = CL5_SUCCESS;
-    Object *tmpObj;
-    CL5DBFile *file;
-    char *file_name;
-
-    PR_ASSERT(replName && replGen);
-
-    if (checkDups) {
-        PR_Lock(s_cl5Desc.fileLock);
-        file_name = _cl5MakeFileName(replName, replGen);
-        tmpObj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, file_name);
-        slapi_ch_free((void **)&file_name);
-        if (tmpObj) /* this file already exist */
-        {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5DBOpenFileByReplicaName - Found DB object %p for replica %s\n", tmpObj, replName);
-            /* if we were asked for file handle - keep the handle */
-            if (obj) {
-                *obj = tmpObj;
-            } else {
-                object_release(tmpObj);
-            }
-
-            rc = CL5_SUCCESS;
-            goto done;
-        }
-    }
-
-    rc = _cl5NewDBFile(replName, replGen, &file);
-    if (rc == CL5_SUCCESS) {
-        /* This creates the file but doesn't set the init flag
-         * The flag is set later when the purge and max ruvs are set.
-         * This is to prevent some thread to get file access before the
-         * structure is fully initialized */
-        rc = _cl5AddDBFile(file, &tmpObj);
-        if (rc == CL5_SUCCESS) {
-            /* read purge RUV - done here because it needs file object rather than file pointer */
-            rc = _cl5ReadRUV(replGen, tmpObj, PR_TRUE);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5DBOpenFileByReplicaName - Failed to get purge RUV\n");
-                goto done;
-            }
-
-            /* read ruv that represents the upper bound of the changes stored in the file */
-            rc = _cl5ReadRUV(replGen, tmpObj, PR_FALSE);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5DBOpenFileByReplicaName - Failed to get upper bound RUV\n");
-                goto done;
-            }
-
-            /* Mark the DB File initialize */
-            _cl5DBFileInitialized(tmpObj);
-
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5DBOpenFileByReplicaName - Created new DB object %p\n", tmpObj);
-            if (obj) {
-                *obj = tmpObj;
-            } else {
-                object_release(tmpObj);
-            }
-        }
-    }
-
-done:;
-    if (rc != CL5_SUCCESS) {
-        if (file)
-            _cl5DBCloseFile((void **)&file);
-    }
-
-    if (checkDups) {
-        PR_Unlock(s_cl5Desc.fileLock);
-    }
-
-    return rc;
-}
-
-/* adds file to the db file list */
-static int
-_cl5AddDBFile(CL5DBFile *file, Object **obj)
-{
-    int rc;
-    Object *tmpObj;
-
-    PR_ASSERT(file);
-
-    tmpObj = object_new(file, _cl5DBCloseFile);
-    rc = objset_add_obj(s_cl5Desc.dbFiles, tmpObj);
-    if (rc != OBJSET_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5AddDBFile - Failed to add db file to the list; "
-                      "repl_objset error - %d\n",
-                      rc);
-        object_release(tmpObj);
-        return CL5_OBJSET_ERROR;
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5AddDBFile - Added new DB object %p\n", tmpObj);
-    }
-
-    if (obj) {
-        *obj = tmpObj;
-    } else
-        object_release(tmpObj);
-
-    return CL5_SUCCESS;
-}
-
-static int
-_cl5NewDBFile(const char *replName, const char *replGen, CL5DBFile **dbFile)
-{
-    int rc;
-    DB *db = NULL;
-    char *name;
-#ifdef HPUX
-    char cwd[PATH_MAX + 1];
-#endif
-
-    PR_ASSERT(replName && replGen && dbFile);
-
-    if (!dbFile) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5NewDBFile - NULL dbFile\n");
-        return CL5_UNKNOWN_ERROR;
-    }
-
-    (*dbFile) = (CL5DBFile *)slapi_ch_calloc(1, sizeof(CL5DBFile));
-    if (*dbFile == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5NewDBFile - memory allocation failed\n");
-        return CL5_MEMORY_ERROR;
-    }
-
-    name = _cl5MakeFileName(replName, replGen);
-    {
-        /* The subname argument allows applications to have
-     * subdatabases, i.e., multiple databases inside of a single
-     * physical file. This is useful when the logical databases
-     * are both numerous and reasonably small, in order to
-     * avoid creating a large number of underlying files.
-     */
-        char *subname = NULL;
-        DB_ENV *dbEnv = s_cl5Desc.dbEnv;
-
-        rc = db_create(&db, dbEnv, 0);
-        if (0 != rc) {
-            goto out;
-        }
-
-        rc = db->set_pagesize(
-            db,
-            s_cl5Desc.dbConfig.pageSize);
-
-        if (0 != rc) {
-            goto out;
-        }
-
-        DB_OPEN(s_cl5Desc.dbEnvOpenFlags,
-                db, NULL /* txnid */, name, subname, DB_BTREE,
-                DB_CREATE | DB_THREAD, s_cl5Desc.dbConfig.fileMode, rc);
-    }
-out:
-    if (rc != 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5NewDBFile - db_open failed; db error - %d %s\n",
-                      rc, db_strerror(rc));
-        rc = CL5_DB_ERROR;
-        goto done;
-    }
-
-    (*dbFile)->db = db;
-    (*dbFile)->name = name;
-    name = NULL; /* transfer ownership to dbFile struct */
-    (*dbFile)->replName = slapi_ch_strdup(replName);
-    (*dbFile)->replGen = slapi_ch_strdup(replGen);
-
-
-    /* compute number of entries in the file */
-    /* ONREPL - to improve performance, we keep entry count in memory
-                and write it down during shutdown. Problem: this will not
-                work with multiple processes. Do we have to worry about that?
-     */
-    if (s_cl5Desc.dbOpenMode == CL5_OPEN_NORMAL) {
-        rc = _cl5GetEntryCount(*dbFile);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5NewDBFile - Failed to get entry count\n");
-            goto done;
-        }
-    }
-
-done:
-    if (rc != CL5_SUCCESS) {
-        _cl5DBCloseFile((void **)dbFile);
-        /* slapi_ch_free accepts NULL pointer */
-        slapi_ch_free((void **)&name);
-
-        slapi_ch_free((void **)dbFile);
-    }
-
-    return rc;
-}
-
-static void
-_cl5DBCloseFile(void **data)
-{
-    CL5DBFile *file;
-    int rc = 0;
-
-    PR_ASSERT(data);
-
-    file = *(CL5DBFile **)data;
-
-    PR_ASSERT(file);
-
-    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                       "Closing database %s\n",
-                  file->name);
-
-    /* close the file */
-    /* if this is normal close or close after import, update entry count */
-    if ((s_cl5Desc.dbOpenMode == CL5_OPEN_NORMAL && s_cl5Desc.dbState == CL5_STATE_CLOSING) ||
-        s_cl5Desc.dbOpenMode == CL5_OPEN_LDIF2CL) {
-        _cl5WriteEntryCount(file);
-        _cl5WriteRUV(file, PR_TRUE);
-        _cl5WriteRUV(file, PR_FALSE);
-    }
-
-    /* close the db */
-    if (file->db) {
-        rc = file->db->close(file->db, 0);
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DBCloseFile - "
-                      "Closed the changelog database handle for %s "
-                      "(rc: %d)\n",
-                      file->name, rc);
-        file->db = NULL;
-    }
-
-    if (file->flags & DB_FILE_DELETED) {
-        /* We need to use the libdb API to delete the files, otherwise we'll
-         * run into problems when we try to checkpoint transactions later. */
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                           "removing the changelog %s (flag %d)\n",
-                      file->name, DEFAULT_DB_ENV_OP_FLAGS);
-        rc = s_cl5Desc.dbEnv->dbremove(s_cl5Desc.dbEnv, 0, file->name, 0,
-                                       DEFAULT_DB_ENV_OP_FLAGS);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                               "failed to remove (%s) file; libdb error - %d (%s)\n",
-                          file->name, rc, db_strerror(rc));
-        } else {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                               "Deleted the changelog database file %s\n",
-                          file->name);
-        }
-    }
-
-    /* slapi_ch_free accepts NULL pointer */
-    slapi_ch_free((void **)&file->name);
-    slapi_ch_free((void **)&file->replName);
-    slapi_ch_free((void **)&file->replGen);
-    ruv_destroy(&file->maxRUV);
-    ruv_destroy(&file->purgeRUV);
-    file->db = NULL;
-
-    slapi_ch_free(data);
-}
-
-static int
-_cl5GetDBFile(Object *replica, Object **obj)
-{
-    char *fileName;
-
-    PR_ASSERT(replica && obj);
-
-    fileName = _cl5Replica2FileName(replica);
-
-    *obj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, fileName);
-    if (*obj) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFile - "
-                                                           "found DB object %p for database %s\n",
-                      *obj, fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_SUCCESS;
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFile - "
-                                                           "no DB object found for database %s\n",
-                      fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_NOTFOUND;
-    }
-}
-
-static int
-_cl5GetDBFileByReplicaName(const char *replName, const char *replGen, Object **obj)
-{
-    char *fileName;
-
-    PR_ASSERT(replName && replGen && obj);
-
-    fileName = _cl5MakeFileName(replName, replGen);
-
-    *obj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, fileName);
-    if (*obj) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFileByReplicaName - "
-                                                           "found DB object %p for database %s\n",
-                      *obj, fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_SUCCESS;
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFileByReplicaName - "
-                                                           "no DB object found for database %s\n",
-                      fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_NOTFOUND;
-    }
-}
-
-static void
-_cl5DBDeleteFile(Object *obj)
-{
-    CL5DBFile *file;
-    int rc = 0;
-
-    PR_ASSERT(obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
-    file->flags |= DB_FILE_DELETED;
-    rc = objset_remove_obj(s_cl5Desc.dbFiles, obj);
-    if (rc != OBJSET_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBDeleteFile - "
-                                                           "could not find DB object %p\n",
-                      obj);
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBDeleteFile - "
-                                                           "removed DB object %p\n",
-                      obj);
-    }
-    object_release(obj);
-}
-
-static void
-_cl5DBFileInitialized(Object *obj)
-{
-    CL5DBFile *file;
-
-    PR_ASSERT(obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
-    file->flags |= DB_FILE_INIT;
-}
-
-static int
-_cl5CompareDBFile(Object *el1, const void *el2)
-{
-    CL5DBFile *file;
-    const char *name;
-
-    PR_ASSERT(el1 && el2);
-
-    file = (CL5DBFile *)object_get_data(el1);
-    name = (const char *)el2;
-    return ((file->flags & DB_FILE_INIT) ? strcmp(file->name, name) : 1);
-}
-
-/*
- * return 1: true (the "filename" ends with "ext")
- * return 0: false
- */
 static int
-_cl5FileEndsWith(const char *filename, const char *ext)
-{
-    char *p = NULL;
-    int flen = strlen(filename);
-    int elen = strlen(ext);
-    if (0 == flen || 0 == elen) {
-        return 0;
-    }
-    p = PL_strrstr(filename, ext);
-    if (NULL == p) {
-        return 0;
-    }
-    if (p - filename + elen == flen) {
-        return 1;
-    }
-    return 0;
-}
-
-static int
-_cl5ExportFile(PRFileDesc *prFile, Object *obj)
+_cl5ExportFile (PRFileDesc *prFile, cldb_Handle *cldb)
 {
     int rc;
     void *iterator = NULL;
@@ -6088,23 +4725,19 @@ _cl5ExportFile(PRFileDesc *prFile, Object *obj)
     char *buff;
     PRInt32 len, wlen;
     CL5Entry entry;
-    CL5DBFile *file;
 
-    PR_ASSERT(prFile && obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
+    PR_ASSERT(cldb);
 
     if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-        ruv_dump(file->purgeRUV, "clpurgeruv", prFile);
-        ruv_dump(file->maxRUV, "clmaxruv", prFile);
+        ruv_dump(cldb->purgeRUV, "clpurgeruv", prFile);
+        ruv_dump(cldb->maxRUV, "clmaxruv", prFile);
     }
     slapi_write_buffer(prFile, "\n", strlen("\n"));
 
     entry.op = &op;
-    rc = _cl5GetFirstEntry(obj, &entry, &iterator, NULL);
+    rc = _cl5GetFirstEntry(cldb, &entry, &iterator, NULL);
     while (rc == CL5_SUCCESS) {
-        rc = _cl5Operation2LDIF(&op, file->replGen, &buff, &len);
+        rc = _cl5Operation2LDIF(&op, cldb->ident, &buff, &len);
         if (rc != CL5_SUCCESS) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "_cl5ExportFile - Failed to convert operation to ldif\n");
@@ -6142,22 +4775,6 @@ _cl5ExportFile(PRFileDesc *prFile, Object *obj)
     return rc;
 }
 
-static PRBool
-_cl5ReplicaInList(Object *replica, Object **replicas)
-{
-    int i;
-
-    PR_ASSERT(replica && replicas);
-
-    /* ONREPL I think it should be sufficient to just compare replica pointers */
-    for (i = 0; replicas[i]; i++) {
-        if (replica == replicas[i])
-            return PR_TRUE;
-    }
-
-    return PR_FALSE;
-}
-
 static char *
 _cl5GetHelperEntryKey(int type, char *csnStr)
 {
@@ -6173,46 +4790,6 @@ _cl5GetHelperEntryKey(int type, char *csnStr)
     return rt;
 }
 
-static Object *
-_cl5GetReplica(const slapi_operation_parameters *op, const char *replGen)
-{
-    Slapi_DN *sdn;
-    Object *replObj;
-    Replica *replica;
-    char *newGen;
-
-    PR_ASSERT(op && replGen);
-
-    sdn = op->target_address.sdn;
-
-    replObj = replica_get_replica_from_dn(sdn);
-    if (replObj) {
-        /* check to see if replica generation has not change */
-        replica = (Replica *)object_get_data(replObj);
-        PR_ASSERT(replica);
-        newGen = replica_get_generation(replica);
-        PR_ASSERT(newGen);
-        if (strcmp(replGen, newGen) != 0) {
-            object_release(replObj);
-            replObj = NULL;
-        }
-
-        slapi_ch_free((void **)&newGen);
-    }
-
-    return replObj;
-}
-
-int
-cl5_is_diskfull()
-{
-    int rc;
-    PR_Lock(cl5_diskfull_lock);
-    rc = cl5_diskfull_flag;
-    PR_Unlock(cl5_diskfull_lock);
-    return rc;
-}
-
 static void
 cl5_set_diskfull(void)
 {
@@ -6221,102 +4798,35 @@ cl5_set_diskfull(void)
     PR_Unlock(cl5_diskfull_lock);
 }
 
-static void
-cl5_set_no_diskfull(void)
-{
-    PR_Lock(cl5_diskfull_lock);
-    cl5_diskfull_flag = 0;
-    PR_Unlock(cl5_diskfull_lock);
-}
-
-int
-cl5_diskspace_is_available()
+/*
+ * Write RUVs into the changelog;
+ * implemented for backup to make sure the backed up changelog contains RUVs
+ * Return values: 0 -- success
+ *                1 -- failure
+ */
+static int
+_cl5WriteReplicaRUV(Replica *r, void *arg)
 {
-    int rval = 1;
+    int rc = 0;
+    cldb_Handle *cldb = replica_get_file_info(r);
 
-#if defined(OS_solaris) || defined(hpux)
-    struct statvfs fsbuf;
-    if (statvfs(s_cl5Desc.dbDir, &fsbuf) < 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5_diskspace_is_available - Cannot get file system info\n");
-        rval = 0;
-    } else {
-        unsigned long fsiz = fsbuf.f_bavail * fsbuf.f_frsize;
-        if (fsiz < NO_DISK_SPACE) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5_diskspace_is_available - No enough diskspace for changelog: (%u bytes free)\n", fsiz);
-            rval = 0;
-        } else if (fsiz > MIN_DISK_SPACE) {
-            /* assume recovered */
-            cl5_set_no_diskfull();
-        }
-    }
-#endif
-#if defined(linux)
-    struct statfs fsbuf;
-    if (statfs(s_cl5Desc.dbDir, &fsbuf) < 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5_diskspace_is_available - Cannot get file system info\n");
-        rval = 0;
-    } else {
-        unsigned long fsiz = fsbuf.f_bavail * fsbuf.f_bsize;
-        if (fsiz < NO_DISK_SPACE) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5_diskspace_is_available - No enough diskspace for changelog: (%lu bytes free)\n", fsiz);
-            rval = 0;
-        } else if (fsiz > MIN_DISK_SPACE) {
-            /* assume recovered */
-            cl5_set_no_diskfull();
-        }
+    if (NULL == cldb) {
+        /* TBD should this really happen, do we need an error msg */
+        return rc;
     }
-#endif
-    return rval;
-}
 
-int
-cl5DbDirIsEmpty(const char *dir)
-{
-    PRDir *prDir;
-    PRDirEntry *prDirEntry;
-    int isempty = 1;
+    _cl5WriteEntryCount(cldb);
+    rc = _cl5WriteRUV(cldb, PR_TRUE);
+    rc = _cl5WriteRUV(cldb, PR_FALSE);
 
-    if (!dir || !*dir) {
-        return isempty;
-    }
-    /* assume failure means it does not exist - other failure
-       cases will be handled by code which attempts to create the
-       db in this directory */
-    if (PR_Access(dir, PR_ACCESS_EXISTS)) {
-        return isempty;
-    }
-    prDir = PR_OpenDir(dir);
-    if (prDir == NULL) {
-        return isempty; /* assume failure means does not exist */
-    }
-    while (NULL != (prDirEntry = PR_ReadDir(prDir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == prDirEntry->name) { /* NSPR doesn't behave like the docs say it should */
-            break;
-        }
-        isempty = 0; /* found at least one "real" file */
-        break;
-    }
-    PR_CloseDir(prDir);
+    return rc;
 
-    return isempty;
 }
 
-/*
- * Write RUVs into the changelog;
- * implemented for backup to make sure the backed up changelog contains RUVs
- * Return values: 0 -- success
- *                1 -- failure
- */
 int
 cl5WriteRUV()
 {
     int rc = 0;
-    Object *file_obj = NULL;
-    CL5DBFile *dbfile = NULL;
     int closeit = 0;
     int slapd_pid = 0;
 
@@ -6324,12 +4834,6 @@ cl5WriteRUV()
 
     /* read changelog configuration */
     changelog5_read_config(&config);
-    if (config.dir == NULL) {
-        /* Changelog is not configured; Replication is not enabled.
-         * we don't have to update RUVs.
-         * bail out - return success */
-        goto bail;
-    }
 
     slapd_pid = is_slapd_running();
     if (slapd_pid <= 0) {
@@ -6356,7 +4860,7 @@ cl5WriteRUV()
     /* file is stored in the changelog directory and is named
      *        <replica name>.ldif */
     if (CL5_STATE_OPEN != s_cl5Desc.dbState) {
-        rc = _cl5Open(config.dir, &config.dbconfig, CL5_OPEN_NORMAL);
+        rc = _cl5Open(&config.dbconfig, CL5_OPEN_NORMAL);
         if (rc != CL5_SUCCESS) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "cl5WriteRUV - Failed to open changelog\n");
@@ -6366,16 +4870,7 @@ cl5WriteRUV()
         closeit = 1;                        /* It had not been opened; close it */
     }
 
-    file_obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (file_obj) {
-        dbfile = (CL5DBFile *)object_get_data(file_obj);
-        if (dbfile) {
-            _cl5WriteEntryCount(dbfile);
-            _cl5WriteRUV(dbfile, PR_TRUE);
-            _cl5WriteRUV(dbfile, PR_FALSE);
-        }
-        file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
-    }
+    replica_enumerate_replicas(_cl5WriteReplicaRUV, NULL);
 bail:
     if (closeit && (CL5_STATE_OPEN == s_cl5Desc.dbState)) {
         _cl5Close();
@@ -6391,12 +4886,40 @@ bail:
  * Return values: 0 -- success
  *                1 -- failure
  */
+static int
+_cl5DeleteRUV(Replica *r, void *arg)
+{
+    int rc = -1;
+    cldb_Handle *cldb = replica_get_file_info(r);
+
+    /* _cl5GetEntryCount deletes entry count after reading it */
+    rc = _cl5GetEntryCount(cldb);
+    if (rc != CL5_SUCCESS) {
+        slapi_log_error(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                        "cl5DeleteRUV: failed to get/delete entry count\n");
+        goto bail;
+    }
+    /* _cl5ReadRUV deletes RUV after reading it */
+    rc = _cl5ReadRUV (cldb, PR_TRUE);
+    if (rc != CL5_SUCCESS) {
+        slapi_log_error(SLAPI_LOG_FATAL, repl_plugin_name_cl,
+                       "cl5DeleteRUV: failed to read/delete purge RUV\n");
+        goto bail;
+    }
+    rc = _cl5ReadRUV (cldb, PR_FALSE);
+    if (rc != CL5_SUCCESS) {
+        slapi_log_error(SLAPI_LOG_FATAL, repl_plugin_name_cl,
+                       "cl5DeleteRUV: failed to read/delete upper bound RUV\n");
+        goto bail;
+    }
+    rc = 0;
+bail:
+    return rc;
+}
 int
 cl5DeleteRUV()
 {
     int rc = 0;
-    Object *file_obj = NULL;
-    CL5DBFile *dbfile = NULL;
     int slapd_pid = 0;
     int closeit = 0;
 
@@ -6404,12 +4927,6 @@ cl5DeleteRUV()
 
     /* read changelog configuration */
     changelog5_read_config(&config);
-    if (config.dir == NULL) {
-        /* Changelog is not configured; Replication is not enabled.
-         * we don't have to update RUVs.
-         * bail out - return success */
-        goto bail;
-    }
 
     slapd_pid = is_slapd_running();
     if (slapd_pid <= 0) {
@@ -6435,7 +4952,7 @@ cl5DeleteRUV()
     /* file is stored in the changelog directory and is named
      *        <replica name>.ldif */
     if (CL5_STATE_OPEN != s_cl5Desc.dbState) {
-        rc = _cl5Open(config.dir, &config.dbconfig, CL5_OPEN_NORMAL);
+        rc = _cl5Open(&config.dbconfig, CL5_OPEN_NORMAL);
         if (rc != CL5_SUCCESS) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "cl5DeleteRUV - Failed to open changelog\n");
